# Agreement - linguistics

In linguistics, agreement or concord (abbreviated agr) occurs when a word changes form depending on the other words to which it relates. 

For example: the subject and the verb match syntactic categories `person` and `number`.

    "The child is playing"
    "The children are playing"

## Forms of agreement

Most important forms of agreement:

* subject and verb agree on person
* subject and verb agree on number
* noun and modifiers agree on gender
* noun and modifiers agree on case

Agreement is based on syntactic categories:

* person: first person (the speaker), second person (the addressee), third person (others)
* number: singular, plural
* gender: masculine, feminine, neuter
* case: nominative (subject), accusative (direct object), genitive (modifying a noun)

Agreement is syntactic in nature. If the gender of a word is "masculine" this does not mean the entity it refers to is necessarily male.

## References

* https://en.wikipedia.org/wiki/Agreement_(linguistics)

