# Anaphora - linguistics

Language has a number of ways in which one noun phrase refers to another, in the same dialog. Typically this can take the form of pronouns (he, she, it), but the range of expressions is actually quite extensive. 

## The facts

Any noun phrase is a reference. It is a description of an entity and what that entity is, needs to be discovered. And since anaphora is so common for noun phrases, it makes sense to treat any noun phrase as anaphoric.

Anaphora has the following aspects

- references to discourse entities (anaphoric) vs references without discourse entities; these refer to the world (nonanaphoric)
- references to determinate entities ("the", names) (definite references) vs indeterminate entities ("a") (indefinite references)
- definite vs indefinite references ("the car", "a car") ("If Pedro owns some donkey, he beats it.")
- references to concepts ("what's the action radius of an electric car?") 
- plural vs singular references ("they", "she")
- pronouns ("it") vs descriptions ("the blue car")
- the type of entity is often specified ("the car")
- reflexive ("himself") vs nonreflexive ("him")
- within sentence references (intrasentential) vs references to other sentences (intersentential)
- back-references (anaphoric) vs forward references (cataphoric)
- direct references ("the car") vs indirect references (referring to an entity that can be deduced) ("My car broke down. The engine failed.")
- may require complex interpretation via world knowledge / selectional restrictions ("The city councilmen refused the demonstrators a permit because they [feared/advocated] violence.")
- it may refer to NP's but also to VP's and S's.
- pick one from a group. "We found seven coins on the next dive. The oldest was dated 1823" (Natural Language Understanding, p348)
- one-anaphora: "How many blocks are in the box? Pick one out." ("one" refers to any block)
- bound variable anaphora: "Every student has received his grade" https://en.wikipedia.org/wiki/Bound_variable_pronoun
- pleonastic/expletive use "It is raining". Is not a reference.
- sense and reference: "the morning star is the evening star"
- referential chains / labels: once "it" refers to A, it should not be resolved in the following sentences, it automatically resolves to A

## Referents

What are the linguistically relevant features of the entities (anaphors) refered to? They have

- a gender: male, female
- animatedness: animate, inanimate
- number: singular, plural (entities that are known as a group)
- a type: car, person, thing, activity
- selectional restrictions: (the things they can do, "birds fly", "cars break down")
- a domain: in the discourse, in a conceptual structure, in the world

## References

What are the features of the references? They have

- a domain: in the discourse ("he"), conceptually related entities ("the engine of the car"), in the world ("My car")
- a number: singular, plural
- a phrase type: noun, verb
- animatedness: animate ("she"), inanimate ("it")
- a gender: male, female
- a specification: car, person, thing, on the left, that my mother liked
- a focus: single entity (definite), set of entities (indefinite)
- a lexical scope: reflexive (same clause), intersentential, intrasentential
- a direction: anaphora (backward), cataphora (forward)
- a phrase type: noun, verb

